<template>
    <div style="height: 100vh" class="container">
        <div class="content-block">
            <h1 v-if="!error">Идет авторизация...</h1>
            <div v-else class="warning-block">
                <b>Ошибка</b><br>
                {{error}}
            </div>
        </div>
    </div>
</template>

<script>
	export default {
		name: 'autologin',
		data() {
			return {
				error: '',
			};
		},
		created() {
			this.AJAX_LOADING({
				caption: 'Авторизация',
				waitingTitle: 'Загрузка данных',
				isShow: true,
				name: 'rootFixed',
			});
			const hash = this.$route.params.hash;
			this.$backend.api.autologin.get(hash).then(({data}) => {
				this.$methods.user.setToken(data.data);

				return this.$methods.user.getUserData().then(async () => {
					console.log('%cSuccess auth', 'color: green');
				}).then(() => {
					console.log('%cGet loans data', 'color: gray');
					return new Promise((resolve, reject) => {
						this.$methods.loan.getLoans().then(() => {
							console.log('%cLoans data loaded', 'color: green');
							this.$methods.user.redirect();
							return resolve();
						}).catch((code) => {
							return reject(code);
						});
					});
				}).catch(() => {
					this.$methods.user.logout();
				}).finally(() => {
					console.log('%cAll done', 'color: green;font-weight: bold');
					this.AJAX_LOADING(false);

				});
			}).catch((e) => {
				this.$error(e, {
					hashNotFound: 'Неверные параметры',
					notActiveHash: 'Ссылка была активирована ранее',
					hashExpired: 'Ссылка устарела',
				}, 'Произошла ошибка авторизации.');
				this.$methods.user.logout();
			}).finally(() => {
				this.AJAX_LOADING(false);
			});
		},
	};
</script>

<style scoped>

</style>
